-------------------------------------------------------------------------------
-- This file is part of libsparkcrypto.
--
-- Copyright (C) 2010, Alexander Senier
-- Copyright (C) 2010, secunet Security Networks AG
-- All rights reserved.
--
-- Redistribution  and  use  in  source  and  binary  forms,  with  or  without
-- modification, are permitted provided that the following conditions are met:
--
--    * Redistributions of source code must retain the above copyright notice,
--      this list of conditions and the following disclaimer.
--
--    * Redistributions in binary form must reproduce the above copyright
--      notice, this list of conditions and the following disclaimer in the
--      documentation and/or other materials provided with the distribution.
--
--    * Neither the name of the  nor the names of its contributors may be used
--      to endorse or promote products derived from this software without
--      specific prior written permission.
--
-- THIS SOFTWARE IS PROVIDED BY THE  COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
-- AND ANY  EXPRESS OR IMPLIED WARRANTIES,  INCLUDING, BUT NOT LIMITED  TO, THE
-- IMPLIED WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR  A PARTICULAR PURPOSE
-- ARE  DISCLAIMED. IN  NO EVENT  SHALL  THE COPYRIGHT  HOLDER OR  CONTRIBUTORS
-- BE  LIABLE FOR  ANY  DIRECT, INDIRECT,  INCIDENTAL,  SPECIAL, EXEMPLARY,  OR
-- CONSEQUENTIAL  DAMAGES  (INCLUDING,  BUT  NOT  LIMITED  TO,  PROCUREMENT  OF
-- SUBSTITUTE GOODS  OR SERVICES; LOSS  OF USE,  DATA, OR PROFITS;  OR BUSINESS
-- INTERRUPTION)  HOWEVER CAUSED  AND ON  ANY THEORY  OF LIABILITY,  WHETHER IN
-- CONTRACT,  STRICT LIABILITY,  OR  TORT (INCLUDING  NEGLIGENCE OR  OTHERWISE)
-- ARISING IN ANY WAY  OUT OF THE USE OF THIS SOFTWARE, EVEN  IF ADVISED OF THE
-- POSSIBILITY OF SUCH DAMAGE.
-------------------------------------------------------------------------------

with LSC.Types;
--# inherit
--#    LSC.Ops64,
--#    LSC.Types,
--#    LSC.Byteswap64;

-------------------------------------------------------------------------------
-- Byte order conversion for 64-bit words
-------------------------------------------------------------------------------
package LSC.Byteorder64 is

   -- Convert 64-bit word @Item@ from native byte order to big endian
   function Native_To_BE (Item : Types.Word64) return Types.Word64;
   pragma Inline (Native_To_BE);

   -- Convert 64-bit word @Item@ from native byte order to little endian
   function Native_To_LE (Item : Types.Word64) return Types.Word64;
   pragma Inline (Native_To_LE);

   -- Convert 64-bit word @Item@ from big endian to native byte order
   function BE_To_Native (Item : Types.Word64) return Types.Word64;
   pragma Inline (BE_To_Native);

   -- Convert 64-bit word @Item@ from little endian to native byte order
   function LE_To_Native (Item : Types.Word64) return Types.Word64;
   pragma Inline (LE_To_Native);

end LSC.Byteorder64;
